/*
//----------------------------------------------
//  Please do not modify and/or redistribute this code.  
//  Copyright (c) 2006 Kristan M. Kenney.  All rights reserved.
//----------------------------------------------
*/

var wmiLocator;
var scopesKeyPath = 'Software\\Microsoft\\Internet Explorer\\SearchScopes';
var wshObj        = new ActiveXObject( 'Wscript.Shell' );
var defaultScope = '';

var searchDisplayName = '';
var searchURL         = '';

System.Gadget.settingsUI        = "Settings.html";
System.Gadget.onSettingsClosing = settingsChangeHandler;

function doInit()
{
	System.Gadget.onSettingsClosed = doInit;

	try
	{
		defaultScope = wshObj.RegRead( 'HKCU\\' + scopesKeyPath + '\\DefaultScope' );
	}
	catch(e){}

	var defaultScopesArray = returnSettingsScopes();
	var multipleScopes = System.Gadget.Settings.read( 'multipleScopes' );

	var searchBox = document.getElementById( 'searchBox' );

	if ( multipleScopes )
	{
		searchURL = "";
		searchDisplayName = "Multiple Prov...";
	}
	else
	{
		var searchScopes = returnSearchScopes();

		for ( var i in searchScopes )
		{
			var thisScopeID = searchScopes[i]['id'];

			if ( searchScopes[i]['IsDefault'] && !defaultScopesArray )
			{
				searchDisplayName = searchScopes[i]['DisplayName'];
				searchURL = searchScopes[i]['URL'];

				break;
			}
			else if ( defaultScopesArray )
			{
				if ( thisScopeID == defaultScopesArray )
				{
					searchDisplayName = searchScopes[i]['DisplayName'];
					searchURL = searchScopes[i]['URL'];

					break;
				}
			}
		}
	}

	searchBox.className = 'boxUnfocus';
	searchBox.value = searchDisplayName;
}


function doSearch()
{
	var searchBox = document.getElementById( 'searchBox' );

	var defaultScopesArray = returnSettingsScopes();
	var searchScopes = returnSearchScopes();
	var multipleScopes = System.Gadget.Settings.read( 'multipleScopes' );


	if ( !multipleScopes )
	{
		var sQueryURL = parseSearchURL( searchURL, searchBox.value );

		System.Shell.execute( sQueryURL );
	}
	else
	{
		for ( var i in searchScopes )
		{
			for ( var i2 in defaultScopesArray )
			{
				if ( defaultScopesArray[i2] == searchScopes[i]['id'] )
				{
					sQueryURL = parseSearchURL( searchScopes[i]['URL'], searchBox.value );

					System.Shell.execute( sQueryURL );
				}
			}
		}
	}

	if ( System.Gadget.Settings.read( 'clearBoxOnSearch' ) == true )
	{
		searchBox.className = 'boxUnfocus';
		searchBox.value = searchDisplayName;
	}

	searchBox.blur();

	return false;
}


function parseSearchURL( inputURL, searchKeywords )
{
	var sQueryURL = inputURL;

	var sQuery = searchKeywords.replace( /\s/g, '+' );
	sQuery = escape( sQuery );

	sQueryURL = sQueryURL.replace( /{searchTerms}/g, sQuery );
	sQueryURL = sQueryURL.replace( /{inputEncoding}/g, 'UTF-8' );
	sQueryURL = sQueryURL.replace( /{outputEncoding}/g, 'UTF-8' );
	sQueryURL = sQueryURL.replace( /{startPage}/g, '1' );
	sQueryURL = sQueryURL.replace( /{startIndex\??}/g, '0' );
	sQueryURL = sQueryURL.replace( /{language}/g, 'en-US' );

	return sQueryURL;
}

function boxFocus( obj )
{
	if ( obj.value != searchDisplayName )
	{
		obj.select();

		return;
	}

	obj.value = '';
	obj.className = 'boxFocus';
}

function boxBlur( obj )
{
	if ( obj.value ) return;

	obj.className = 'boxUnfocus';
	obj.value = searchDisplayName;
}


function returnSettingsScopes()
{
	var defaultSetting = System.Gadget.Settings.read( 'defaultScopes' );

	if ( !defaultSetting ) return false;

	var scopesArray = Array();

	scopesArray = defaultSetting.split( ',' );

	return scopesArray;
}

function settingsOnLoad()
{
	try
	{
		defaultScope = wshObj.RegRead( 'HKCU\\' + scopesKeyPath + '\\DefaultScope' );
	}
	catch(e){}

	var defaultScopesArray = returnSettingsScopes();

	var providers = document.getElementById( 'providers' );
	var searchProviders = returnSearchScopes();


	for ( var i in searchProviders )
	{
		var thisDispName = searchProviders[i]['DisplayName'];
		var thisID       = searchProviders[i]['id'];
		var thisDefault  = searchProviders[i]['IsDefault'];

		if ( thisDefault ) thisDispName += " (Default)";

		providers.options[i] = new Option( thisDispName, thisID );

		if ( defaultScopesArray )
		{
			for ( var i2 in defaultScopesArray )
			{
				if ( defaultScopesArray[i2] == thisID )
				{
					providers.options[i].selected = true;
				}
			}
		}
		else
		{
			if ( thisDefault )
			{
				providers.options[i].selected = true;
			}
		}
	}

	var providerCount = returnSelectedProviderCount();

	var clearBoxOnSearch = System.Gadget.Settings.read( 'clearBoxOnSearch' );

	if ( clearBoxOnSearch ) document.getElementById( 'clearBoxOnSearch' ).checked = true;
}


function settingsChangeHandler()
{
	var multipleScopes = false;
	var defaultScopeString = '';
	var defaultScopesArray = Array();
	var providers = document.getElementById( 'providers' );

	if ( returnSelectedProviderCount() > 1 ) multipleScopes = true;

	var i2 = 0;

	for ( var i = 0; i < providers.length; i++ )
	{
		if ( !multipleScopes )
		{
			if ( providers[i].selected )
			{
				defaultScopeString = providers[i].value;

				break;
			}
		}
		else
		{
			if ( providers[i].selected )
			{
				defaultScopesArray[i2] = providers[i].value;

				i2++;
			}
		}	
	}

	if ( multipleScopes ) defaultScopeString = defaultScopesArray.join( ',' );

	System.Gadget.Settings.write( 'defaultScopes', defaultScopeString );
	System.Gadget.Settings.write( 'multipleScopes', multipleScopes );
	System.Gadget.Settings.write( 'clearBoxOnSearch', document.getElementById( 'clearBoxOnSearch' ).checked );

}


function returnSelectedProviderCount()
{
	var selectedCount = 0;
	var providers = document.getElementById( 'providers' );

	for ( var i = 0; i < providers.options.length; i++ )
	{
		if ( providers.options[i].selected ) selectedCount++;
	}

	return selectedCount;
}


function providerListChange()
{
	var selectedCount = returnSelectedProviderCount();
}

function fetchRegArray( sKeyPath )
{
	if ( !wmiLocator )
		var wmiLocator = new ActiveXObject( 'WbemScripting.SWbemLocator' );

	var wmiServer     = wmiLocator.ConnectServer( null, 'root\\default' );
	var wmiRegistry   = wmiServer.Get( 'StdRegProv' );
	var enumKeyMethod = wmiRegistry.Methods_.Item( 'EnumKey' );

	var inParams         = enumKeyMethod.inParameters.SpawnInstance_();
	inParams.hDefKey     = 0x80000001; // HKCU
	inParams.sSubKeyName = sKeyPath;

	var outParams = wmiRegistry.ExecMethod_( enumKeyMethod.Name, inParams );
	var subKeys = outParams.sNames.toArray();

	return subKeys;
}


function returnSearchScopes()
{
	var searchScopes = fetchRegArray( scopesKeyPath );
	var defaultExists = false;

	for ( var i in searchScopes )
	{

		var thisScopeID = searchScopes[i];

		searchScopes[i] = Array();

		searchScopes[i]['id']          = thisScopeID;
		searchScopes[i]['DisplayName'] = wshObj.RegRead( 'HKCU\\' + scopesKeyPath + '\\' + thisScopeID + '\\DisplayName' );
		searchScopes[i]['URL']         = wshObj.RegRead( 'HKCU\\' + scopesKeyPath + '\\' + thisScopeID + '\\URL' );
		searchScopes[i]['IsDefault']   = ( defaultScope == thisScopeID ) ? true : false;

		if ( searchScopes[i]['IsDefault'] ) defaultExists = true;

		if ( searchScopes[i]['DisplayName'].indexOf( '@ieframe.dll' ) > -1 )
			searchScopes[i]['DisplayName'] = wshObj.RegRead( 'HKCU\\' + scopesKeyPath + '\\' + thisScopeID + '\\' );
	}

	if ( !defaultExists ) searchScopes[0]['IsDefault'] = true;

	return searchScopes;
}


